#ifdef ASYN_SOCK_REL

// *************************************************************************
//    AsynSockRelation.h
// *************************************************************************

#ifndef _AsynSockRelation_H_
#define _AsynSockRelation_H_

#include "StorageRelation.h"
#include "RelationList.h"
#include "Debug.h"
#include "Config.h"
#include "CoralStream.h"
#include "SockStream.h"
#include "DerivedRelation.h"
#include "HashSimpleRelation.h"

#define MAX_WSNAME_LEN 100
#define MAX_HOSTNAME_LEN 100

class Cor_AsynSockRelation : public Cor_DerivedRelation {
private:
    char _local_name[COR_MAX_REL_NAME_LEN];
    int  _arity;
    char _host[MAX_HOSTNAME_LEN];
    int  _port;
    char _work_space[MAX_WSNAME_LEN];
    char _relation_name[COR_MAX_REL_NAME_LEN];

public:

    Cor_AsynSockRelation(char *ln, int arity, char *host, int port,
            char *ws, char *rn);
    
   ~Cor_AsynSockRelation();

    CoralStream *setup();
    
    virtual int insert_tuple(Cor_Tuple *tuple);

    virtual Cor_BindEnv *get_next(Cor_TupleIterator&); 
    virtual Cor_Tuple *get_next_tuple( Cor_TupleIterator& it) ;

    virtual void print_name(ostream *out);

    char *remote_relname() { return(_relation_name); }
};

// *************************************************************************

#endif _AsynSockRelation_H_

#endif // ASYN_SOCK_REL
