// *************************************************************************
//    ClauseNames.h
// *************************************************************************

#ifndef _ClauseNames_H_
#define _ClauseNames_H_

#include <stdio.h>

#include "CArg.h"
#include "Stack.h"
#include "CArg.h"

// *************************************************************************

class  Cor_ClauseNames {

  public:

    Cor_CArgStack    names;
    Cor_IntStack     negated;

    Cor_ClauseNames() { }
   ~Cor_ClauseNames() { }

      // This version of add() adds to the front of the list
      // This function takes over ownership of this pointer
    void add_to_front(Cor_CArg *name, int negted) {
        names.insert_at(0,name);
        negated.insert_at(0,negted);
    }

    // All the following versions of add() add to the end!

      // This function takes over ownership of this pointer
    int add(Cor_CArg *name, int negted) {
        names.push(name);
        return(negated.push(negted));
    }

    int add(Cor_CArg& name, int negted) {
        Cor_CArg *carg = new Cor_CArg(name);
        names.push(carg);
        return(negated.push(negted));
    }

        // Use sprint to get a name from the first integer
    int add(int name, int negted) {
        char label[12];

        sprintf(label,"%d", name);
        Cor_CArg *carg = new Cor_CArg(label);
        names.push(carg);
        return(negated.push(negted));
    }

    int add(char *name, int negted) {
        Cor_CArg *carg = new Cor_CArg(name);
        names.push(carg);
        return(negated.push(negted));
    }

    int count() { return(names.count()); }
    int is_empty() { return(names.is_empty()); }

    char *ith_symbol(int i) { return(names.get_ith(i)->symbol()); }
    int   ith_neg(int i) { return(negated.get_ith(i)); }
    void  set_negated(int i, int val) { negated.set_ith(i,val); }

    void empty() {
        names.empty();
        negated.empty();
    }

    Cor_ClauseNames *dup() {
        Cor_ClauseNames *cnme = new Cor_ClauseNames();
        cnme->names.copy(names);
        cnme->negated.copy(negated);
        return(cnme);
    }
};

// *************************************************************************

#endif _ClauseNames_H_
