//******************************************
//  HashJoin.h
//
// Ravi Murthy
//*****************************************

#ifdef    WITH_PERSISTENCE
#ifndef _HashJoin_H_
#define _HashJoin_H_

#include "Plan.h"
#include "JoinAttrs.h"

// The size of the in memory hash table.
#define TABLE_SIZE 966997

typedef struct Cor_ELEM               // Each entry in the hash table.
{
    Cor_BindEnv *tuple;               // Pointer to the tuple.
    struct Cor_ELEM *next;            // Pointer to the next element.

   ~Cor_ELEM() {
        delete tuple;
    }

} Cor_ELEM;                                

// *************************************************************************
// This class implements the hash join algorithm which joins the tuples
// in two given partitions. 

class Cor_HashJoin {
  public:
    Cor_HashJoin(Cor_TupleIterator* inner, Cor_JoinAttrs *attr);
   ~Cor_HashJoin();

    Cor_Tuple* get_next_tuple(Cor_TupleIterator *outer);

  private:

    Cor_ELEM      *table[TABLE_SIZE];      // The hash table.
    Cor_JoinAttrs *attrs;
    Cor_ArgList inner_arg_list;

    Cor_BindEnv *save_bindenv;
    Cor_BindEnv *probe_bindenv;
    Cor_ELEM *save_elemptr;
    int probe_done;
};

// *************************************************************************
#endif
#endif // WITH_PERSISTENCE
