// *************************************************************************
//    LinkedRelation.h
// *************************************************************************

#ifndef _LinkedRelation_H_
#define _LinkedRelation_H_

#include "Relation.h"
#include "HashIndex.h"
#include "HashIndexSet.h"
#include "Debug.h"

// *************************************************************************

class Cor_LinkedRelation : public Cor_StorageRelation {

  public:
    Cor_HashIndexSet index_set;
    Cor_LinkedRelation(int _arity, int _delta = -1);
    virtual Cor_RMark *getMark();

    virtual int insert_raw(Cor_Tuple *tuple);

    void initialize_iterator(Cor_TupleIterator&);
    virtual Cor_BindEnv *get_next(Cor_TupleIterator&);
    virtual Cor_Tuple *get_next_tuple(Cor_TupleIterator& it);
    virtual void release(Cor_TupleIterator& it);
    virtual int is_subsumed(Cor_Tuple *tuple, Cor_RMark *startmark=NULL,
        Cor_RMark *endmark=NULL);

      // Indexing related methods
    virtual Cor_GenericIndexSet *get_index_set() { return &index_set ;}
    virtual Cor_GenericIndex *create_index_object(Cor_BitVector *bv) {
        return new Cor_HashIndex(this, bv, -1);
    }

    virtual Cor_GenericIndex *create_index_object(Cor_ArgList *pat, int n_var,
        Cor_ArgList *v_nm) {
        return new Cor_HashIndex(this, pat, n_var, v_nm);
    }

    void free_linked_tuples();
    virtual void free_all() { Cor_TupleList::free_all(); }
    virtual void print_name(ostream *out);
    virtual void empty_relation(int deleteTuples=0);
    virtual ~Cor_LinkedRelation() { free_all(); count = 0; }
};

// *************************************************************************

#endif _LinkedRelation_H_
