// *************************************************************************
//    PersistentIndexSet.h
// *************************************************************************

#ifndef _PersistentIndexSet_H_
#define _PersistentIndexSet_H_

#ifdef WITH_PERSISTENCE

#include "GenericIndex.h"
#include "GenericIndexSet.h"


// *************************************************************************

#define Scanning_Persistent 1

#define COR_PERS_INDEX 2

// *************************************************************************

class Cor_PersistentRel;

class Cor_PersistentIndexSet : public Cor_GenericIndexSet {

  public:
    Cor_PersistentIndexSet( Cor_PersistentRel *reln ) : 
      Cor_GenericIndexSet((Cor_StorageRelation *)reln) {};

    // Finds the index that best "matches" the given argument set in
    // the iterator.
    virtual Cor_GenericIndex *find_index( Cor_TupleIterator& iterator) {
        return
            find_index(iterator.arg_list,iterator.bindenv,iterator.indexnump);
    };

    virtual Cor_GenericIndex *find_index(Cor_Tuple *tuple, int *tryindexp=NULL){
        return find_index(*(tuple->_args), NULL, tryindexp);
    };

    virtual Cor_GenericIndex *find_index(Cor_ArgList&, Cor_BindEnv*,
                                int *tryindexp=NULL);

    // Add an index to the set of known indices
    virtual int insert_index(Cor_GenericIndex *index);

    // Fill in the index using default index in posn. 0
    virtual void fill_index(Cor_GenericIndex *Index);
};

// *************************************************************************

#endif WITH_PERSISTENCE

#endif _PersistentIndexSet_H_
