#ifndef _RDBDELETE_H_
#define _RDBDELETE_H_

// A RdbDelete represents a delete statement on relation, for a given
// set of bindings.

#include "RdbRelation.h"
#include "RdbCompilableDML.h"
#include "RdbItem.h"
#include "BitVector.h"


class RdbDelete
: public RdbCompilableDML
{
  public:  

    RdbDelete(const RdbRelation& newRel, const BitVector& newAdorn);

    virtual ~RdbDelete();

    ErrorCode Delete(const RdbItemList& bindings);

    const BitVector& Adornment() const;	// return the adornment pattern

  protected:

    const RdbRelation& rel;	// the relation to delete from

    BitVector adorn;		// the expected bindings

    void CreateStmt(const String varPlaceHolder = questionMark,
		    const int addSequence = 0);	
				// create the ansi sql delete statement
				// it uses varPlaceHolder to mark parameters
				// to the statement, adding a sequence number
				// if addSequence is 1

    void CreateStmt(const RdbItemList& bindings);
				// create the ansi sql delete statement
				// but directly place in values, not vars.

    virtual ErrorCode VDelete(const RdbItemList& bindings) = 0;

  private:

    RdbDelete(const RdbDelete&); // na

    RdbDelete& operator =(const RdbDelete&); // na
};


#include "RdbDelete.i"

#endif // _RDBDELETE_H_
