# line 1 "RdbIngresDelete.scc"	

#include "RdbIngresDelete.h"
#include "Log.h"

#ifndef _SQLCA_H_
# include "/ingres/r6/ingres/files/eqsqlca.h"
    extern IISQLCA sqlca;   /* SQL Communications Area */
#endif
#ifndef _SQLDA_H_
# include "/ingres/r6/ingres/files/eqsqlda.h"
#endif
#include "IngresProtos.h"


unsigned RdbIngresDelete::deleteNum = 0;

RdbIngresDelete::RdbIngresDelete(const RdbRelation& newRel, 
				 const BitVector& newAdorn)
: RdbDelete(newRel, newAdorn)
{ 
    id = String("del") + deleteNum++; 
    CreateStmt();
    Describe();
}


RdbError::ErrorCode RdbIngresDelete::VDelete(const RdbItemList& bindings)
{
  char *stmt_id = id;

    Bind( bindings );
    IISQLDA* sqlda = bindDA;

    LOG("deleting on stmt "<<stmt_id<<'\n');
# line 36 "RdbIngresDelete.scc"	/* execute */
  {
    IIsqInit(&sqlca);
    IIsqExStmt(stmt_id,(int)0);
    IIsqDaIn((int)0,sqlda);
    IIsyncup("RdbIngresDelete.scc",(int)36);
  }
# line 37 "RdbIngresDelete.scc"	/* host code */
    if( sqlca.sqlcode == 100 )
      return SQL_EOF;		// no matching rows!
    if( sqlca.sqlcode )
      return Error(SQL_ERROR);
    return NO_ERROR;
}


RdbError::ErrorCode RdbIngresDelete::Describe()
{
  char *stmt = statement;
  char *stmt_id = id;

    ErrorCode rc = PrepareDA();
    if( rc )
      return rc;

    LOG("Describing "<<stmt<<'\n');
# line 57 "RdbIngresDelete.scc"	/* prepare */
  {
    IIsqInit(&sqlca);
    IIsqPrepare((int)0,stmt_id,(char *)0,(int)0,stmt);
  }
# line 58 "RdbIngresDelete.scc"	/* host code */
    if( sqlca.sqlcode )
      return Error(SQL_ERROR);
    ready = TRUE;
    return NO_ERROR;
}


RdbError::ErrorCode RdbIngresDelete::PrepareDA()
{
  char *stmt;
  char *stmt_id = id;

    int arity = rel.Arity();
    RdbIngresSqlda tupleDA;
    tupleDA.Resize(arity);
    IISQLDA* sqlda = tupleDA;

    String s("select ");
    s += rel.ColName(0);
    for( int i = 1 ; i < arity ; i++ ) {
	s += String(",") + rel.ColName(i);
    }
    s += String(" from ") + rel.RelName();
    stmt = s;
    LOG("Describing "<<stmt<<'\n');
# line 85 "RdbIngresDelete.scc"	/* prepare */
  {
    IIsqInit(&sqlca);
    IIsqPrepare((int)0,stmt_id,sqlda,(int)0,stmt);
  }
# line 86 "RdbIngresDelete.scc"	/* host code */
    if( sqlca.sqlcode )
      return Error(SQL_ERROR);
    assert(rel.Arity() == tupleDA.Arity());
    bindDA.Prepare( tupleDA, adorn );
    return NO_ERROR;
}


RdbError::ErrorCode RdbIngresDelete::Bind(const RdbItemList& bindings)
{
    int n = bindings.Size();
    if( n != bindDA.Arity() )
      return Error(BAD_ARITY);
    for( int i = 0; i < n ; i++ ) {
	// should probably check for compatiblilty
	bindDA.SetItem( i, bindings[i] );
	LOG("binding it to: "<<bindings[i]<<'\n');
    }
    return NO_ERROR;
}

