#ifndef _CRDBMANAGER_H_
#define _CRDBMANAGER_H_

// calculate DO_RDB from particular db's
#if defined(DO_INGRES) || defined(DO_SYBASE) || defined(DO_INFORMIX)
#  if !defined(DO_RDB)		// in case it's defined by command line...
#    define DO_RDB
#  endif
#endif


#ifdef DO_RDB

#include "RdbManager.h"
#include "String.h"
#include "List.h"
#include "CRdbRelation.h"
#include "Debug.h"

// forward declarations
class RdbDatabase;



class Cor_CRdbManager
: public RdbManager
{
  public:
    
    Cor_CRdbManager();

    ~Cor_CRdbManager();

//    void StoreCRdbRelation(CRdbRelation *crel);

//    void RemoveCRdbRelation(CRdbRelation *crel); // Does not Delete!!

//------------- WORKSPACE STUFF ---------------------------------------------

    void StoreDatabase(const String name, RdbDatabase *db);

    RdbDatabase *LookupDatabase(const String name);

    

//---------------------------------------------------------------------------

  private:

//------------- WORKSPACE STUFF ---------------------------------------------
    // eventually, this stuff will become part of the database (workspace)
    // class hierarchy, which doesn't exist yet...
    class Cor_DBEntry
      {
	public:

	  Cor_DBEntry(const String newName, RdbDatabase *newDb);

	  ~Cor_DBEntry();

	  List<String> nameList;

	  RdbDatabase *db;

      };

    typedef DList<Cor_DBEntry> DBList;

    DBList dbList;

//---------------------------------------------------------------------------
//           Must delete any coral-rdb relations before deleting databases

//    typedef PtrList<CRdbRelation> CRelList;

//    CRelList crelList;


//---------------------------------------------------------------------------
};


// Global variables:
extern Cor_CRdbManager *pCRdbManager;


//---------------------------------------------------------------------------

#endif // DO_RDB

#endif // _CRDBMANAGER_H_
