

#include    "Tuple.h"
#include    "TupleIterator.h"
//#include    "LinkedRelation.h"

#include    "AggSelInfo.h"
#include    "Annotations.h"
#include    "ArgList.h"
#include    "Assert.h"
#include    "BacktrackInfoArray.h"
#include    "BindEnv.h"
#include    "BindTime.h"
#include    "BitVector.h"
#include    "BuiltinBinaryRelation.h"
#include    "BuiltinCompareRelation.h"
#include    "BuiltinDebugRelation.h"
#include    "BuiltinFailRelation.h"
#include    "BuiltinIndexRelation.h"
#include    "BuiltinRelation.h"
#include    "BuiltinSetRelation.h"
#include    "BuiltinSymbols.h"
#include    "BuiltinTraceRelation.h"
#include    "BuiltinUnaryRelation.h"
#include    "BuiltinUserRelRelation.h"
#include    "BuiltinUserTupleRelation.h"
#include    "BuiltinUtil.h"
#include    "CArg.h"
#include    "CArg.i"
#include    "CArgUtil.h"
#include    "ClauseNames.h"
#include    "ClientProtocol.h"
#include    "Collection.h"
#include    "Compile.h"
#include    "CompileRule.h"
#include    "Config.h"
#include    "ConnectArray.h"
#include    "Connection.h"
#include    "Context.h"
#include    "ContextNode.h"
#include    "CoralBreak.h"
#include    "CoralConfig.h"
#include    "CoralError.h"
#include    "CoralIncludes.h"
#include    "CoralInit.h"
#include    "CoralStream.h"
#include    "DBSolvers.h"
#include    "Database.h"
#include    "DatabaseStruct.h"
#include    "Debug.h"
#include    "DebugSolvers.h"
#include    "DerivedMethod.h"
#include    "DerivedRelation.h"
#include    "Entity.h"
#include    "Execute.h"
#include    "ExecutionEnv.h"
#include    "ExportInfo.h"

#include    "GenericIndex.h"
#include    "GenericIndexSet.h"
#include    "GlobalBuiltinVars.h"
#include    "Globals.h"
#include    "GoalNode.h"
#include    "GoalNodeLink.h"
#include    "HashIndex.h"
#include    "HashIndexSet.h"
#include    "HashSimpleRelation.h"
#include    "HashVal.h"
#include    "History.h"
#include    "IO_Solvers.h"
#include    "Identify.h"
#include    "InitBuiltins.h"
#include    "Interface.h"
#include    "Literal.h"
#include    "LocalConnectArray.h"
#include    "ModuleEnv.h"
#include    "ModuleExecInfo.h"
#include    "ModuleInfo.h"
#include    "ModulePred.h"
#include    "New.h"
#include    "Operators.h"
#include    "ParseActions.h"
#include    "ParseStack.h"
#include    "ParseUtils.h"
#include    "ParserEnv.h"
#include    "ParserStruct.h"

#include    "Pipelined.h"
#include    "PipelinedDerivedRelation.h"
#include    "PipelinedExecInfo.h"
#include    "PredAnnotations.h"
#include    "Predicate.h"
#include    "Profile.h"
#include    "QFMaterializedModuleData.h"
#include    "QFModuleData.h"
#include    "QFPipelinedModuleData.h"
#include    "RMark.h"
#include    "RMarkArray.h"

//#include    "Reference.h"

#include    "Relation.h"
#include    "RelationList.h"
#include    "RelationMisc.h"
#include    "RelationStruct.h"
#include    "Rewriting.h"
#include    "Rule.h"
#include    "RuleEnv.h"
#include    "RuleInfo.h"
#include    "RuleInfoArray.h"
#include    "Scanner.h"
#include    "Scc.h"
#include    "SccEnv.h"
#include    "SccInfo.h"
#include    "SccWork.h"
#include    "Schema.h"
#include    "SemiNaive.h"
#include    "ServerSolvers.h"
#include    "SetSolvers.h"
#include    "Sips.h"
#include    "SockConnectArray.h"
#include    "SockRelation.h"
#include    "SockStream.h"
#include    "SocketRelSolver.h"
#include    "Solvers.h"
#include    "Stack.h"
#include    "StackMark.h"
#include    "StorageRelation.h"
#include    "StrRefTable.h"
#include    "Suspend.h"
#include    "Suspension.h"
#include    "SymTable.h"
#include    "Table.h"
#include    "TableStack.h"
#include    "Term.h"
#include    "Trail.h"
#include    "TupleList.h"
#include    "Unify.h"
#include    "Unparse.h"
#include    "User.h"
#include    "Util.h"


#ifdef    0
#include    "PvmConnectArray.h"
#include    "PvmStream.h"
#include    "WodiStream.h"
#endif

#ifdef    0
#include    "BoundArgList.h"
#include    "CRdbDatabase.h"
#include    "CRdbManager.h"
#include    "CRdbRelation.h"
#include    "CRdbSolvers.h"
#endif

#ifdef    0
#include    "BufferGroup.h"
#include    "BPlusTreeIndex.h"
#include    "Catalog.h"
#include    "IndexStruct.h"
#include    "FileDescStruct.h"
#include    "PersistentIndex.h"
#include    "PersistentIndexSet.h"
#include    "PersistentRelation.h"
#include    "SMUtil.h"
#include    "StorageManager.h"
#include    "Transaction.h"
#endif

/************/

void show_sizes()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    cout << endl;

    cout << "sizeof(CArg): " << sizeof(Cor_CArg) << endl;
    cout << "sizeof(ArgList): " << sizeof(Cor_ArgList) << endl;
    cout << "sizeof(BindEnv): " << sizeof(Cor_BindEnv) << endl;
    cout << "sizeof(BitVector): " << sizeof(Cor_BitVector) << endl;
    cout << endl;

    cout << "sizeof(SuspendContext): " << sizeof(Cor_SuspendContext) << endl;
    cout << "sizeof(suspensionClass): " << sizeof(Cor_suspensionClass) << endl;
    cout << "sizeof(Collection): " << sizeof(Cor_Collection) << endl;
    cout << "sizeof(Relation) " << sizeof(Cor_Relation) << endl;
    cout << "sizeof(StorageRelation) " << sizeof(Cor_StorageRelation) << endl;
    cout << "sizeof(HashSimpleRelation) "
         << sizeof(Cor_HashSimpleRelation) << endl;


    cout << "sizeof(AggSelInfo): " << sizeof(Cor_AggSelInfo) << endl;
    cout << "sizeof(AliasList): " << sizeof(Cor_AliasList) << endl;
    cout << endl;

    cout << "sizeof(break_info): " << sizeof(Cor_break_info) << endl;
    cout << "sizeof(BuiltinRelation): "
         << sizeof(Cor_BuiltinRelation) << endl;     
    cout << "sizeof(BuiltinBinaryRelation): "
         << sizeof(Cor_BuiltinBinaryRelation) << endl;
    cout << "sizeof(BuiltinCompareRelation): "
         << sizeof(Cor_BuiltinCompareRelation) << endl;
    cout << "sizeof(BuiltinDebugRelation): "
         << sizeof(Cor_BuiltinDebugRelation) << endl;
    cout << "sizeof(BuiltinFailRelation): "
         << sizeof(Cor_BuiltinFailRelation) << endl;
    cout << "sizeof(BuiltinIndexRelation): "
         << sizeof(Cor_BuiltinIndexRelation) << endl;
    cout << "sizeof(BuiltinSetRelation): "
         << sizeof(Cor_BuiltinSetRelation) << endl; 
    cout << "sizeof(BuiltinTraceRelation): "
         << sizeof(Cor_BuiltinTraceRelation) << endl;
    cout << "sizeof(BuiltinUnaryRelation): "
         << sizeof(Cor_BuiltinUnaryRelation) << endl; 
    cout << "sizeof(BuiltinUserRelRelation): "
         << sizeof(Cor_BuiltinUserRelRelation) << endl;
    cout << "sizeof(BuiltinUserTupleRelation): "
         << sizeof(Cor_BuiltinUserTupleRelation) << endl;

    cout << "sizeof(ScanDesc): " << sizeof(Cor_ScanDesc) << endl;
    cout << "sizeof(Clause): " << sizeof(Cor_Clause) << endl;
    cout << "sizeof(ConnectArray): " << sizeof(Cor_ConnectArray) << endl;
    cout << "sizeof(Connection): " << sizeof(Cor_Connection) << endl;
    cout << "sizeof(Context): " << sizeof(Cor_Context) << endl;
    cout << "sizeof(ContextNode): " << sizeof(Cor_ContextNode) << endl;
    cout << "sizeof(CoralConfig): " << sizeof(CoralConfig) << endl;

    cout << "sizeof(DatabaseStruct): " << sizeof(Cor_DatabaseStruct) << endl;
    cout << "sizeof(DerivedRelation): " << sizeof(Cor_DerivedRelation) << endl; 

    cout << "sizeof(ExecutionEnv): " << sizeof(Cor_ExecutionEnv) << endl;
    cout << "sizeof(ExecutionList): " << sizeof(Cor_ExecutionList) << endl;
    cout << "sizeof(ExportInfo): " << sizeof(Cor_ExportInfo) << endl;


    cout << "sizeof(GenericIndex): " << sizeof(Cor_GenericIndex) << endl;
    cout << "sizeof(GenericIndexSet): " << sizeof(Cor_GenericIndexSet) << endl;
    cout << "sizeof(GoalNode): " << sizeof(Cor_GoalNode) << endl;       
    cout << "sizeof(GoalNodeLink): " << sizeof(Cor_GoalNodeLink) << endl;

    cout << "sizeof(HashNode): " << sizeof(Cor_HashNode) << endl;
    cout << "sizeof(HashIndex): " << sizeof(Cor_HashIndex) << endl;       
    cout << "sizeof(HashIndexSet): " << sizeof(Cor_HashIndexSet) << endl;     
    cout << "sizeof(HashSimpleRelation): "
         << sizeof(Cor_HashSimpleRelation) << endl;
    cout << "sizeof(History): " << sizeof(Cor_History) << endl;

    cout << "sizeof(Literal): " << sizeof(Cor_Literal) << endl;

    cout << "sizeof(ModulePred): " << sizeof(Cor_ModulePred) << endl;
    cout << "sizeof(ModuleInfo): " << sizeof(Cor_ModuleInfo) << endl;
    cout << "sizeof(ModuleEnv): " << sizeof(Cor_ModuleEnv) << endl;

    cout << "sizeof(IntStack): " << sizeof(Cor_IntStack) << endl;
    cout << "sizeof(VoidStack): " << sizeof(Cor_VoidStack) << endl;
    cout << "sizeof(CArgStack): " << sizeof(Cor_CArgStack) << endl;

    cout << "sizeof(ParserEnv): " << sizeof(Cor_ParserEnv) << endl;
    cout << "sizeof(ParserStruct): " << sizeof(Cor_ParserStruct) << endl;
    cout << "sizeof(ParseStack): " << sizeof(Cor_ParseStack) << endl;

    cout << "sizeof(PipelinedDerivedRelation): "
         << sizeof(Cor_PipelinedDerivedRelation) << endl;
    cout << "sizeof(PipelinedExecInfo): "
         << sizeof(Cor_PipelinedExecInfo) << endl;
    cout << "sizeof(PredAnnotations): " << sizeof(Cor_PredAnnotations) << endl;
    cout << "sizeof(Predicate): " << sizeof(Cor_Predicate) << endl;

    cout << "sizeof(QFModuleData): " << sizeof(Cor_QFModuleData) << endl;
        
    cout << "sizeof(QFMaterializedModuleData): "
         << sizeof(Cor_QFMaterializedModuleData) << endl;
    cout << "sizeof(QFPipelinedModuleData): "
         << sizeof(Cor_QFPipelinedModuleData) << endl;

    cout << "sizeof(Relation): " << sizeof(Cor_Relation) << endl;
    cout << "sizeof(RelationLink): " << sizeof(Cor_RelationLink) << endl;
    cout << "sizeof(RelationList): " << sizeof(Cor_RelationList) << endl;
    cout << "sizeof(RelationStruct): " << sizeof(Cor_RelationStruct) << endl;
    cout << "sizeof(RMark): " << sizeof(Cor_RMark) << endl;
    cout << "sizeof(RuleAnno): " << sizeof(Cor_RuleAnno) << endl;
    cout << "sizeof(RuleAnnoCase): " << sizeof(Cor_RuleAnnoCase) << endl;
    cout << "sizeof(RuleAnnoCaseDetails): "
         << sizeof(Cor_RuleAnnoCaseDetails) << endl;

    cout << "sizeof(RuleAnnoCaseName): "
         << sizeof(Cor_RuleAnnoCaseName) << endl;
    cout << "sizeof(RuleAnnotes): " << sizeof(Cor_RuleAnnotes) << endl;
    cout << "sizeof(RuleEnv): " << sizeof(Cor_RuleEnv) << endl;
    cout << "sizeof(RuleInfo): " << sizeof(Cor_RuleInfo) << endl;
    cout << "sizeof(RuleInfoArray): " << sizeof(Cor_RuleInfoArray) << endl;

    cout << "sizeof(SccInfo): " << sizeof(Cor_SccInfo) << endl;
    cout << "sizeof(Schema): " << sizeof(Cor_Schema) << endl;
    cout << "sizeof(StackMark): " << sizeof(Cor_StackMark) << endl;

    cout << "sizeof(StorageRelation): " << sizeof(Cor_StorageRelation) << endl;
    cout << "sizeof(SuspendContext): " << sizeof(Cor_SuspendContext) << endl;
    cout << "sizeof(suspensionClass): " << sizeof(Cor_suspensionClass) << endl;

    cout << "sizeof(Table): " << sizeof(Cor_Table) << endl;
    cout << "sizeof(Term): " << sizeof(Cor_Term) << endl;
    cout << "sizeof(Trail): " << sizeof(Cor_Trail) << endl;
    cout << "sizeof(Tuple): " << sizeof(Cor_Tuple) << endl;
    cout << "sizeof(TupleIterator): " << sizeof(Cor_TupleIterator) << endl;
    cout << "sizeof(TupleLink): " << sizeof(Cor_TupleLink) << endl;
    cout << "sizeof(TupleList): " << sizeof(Cor_TupleList) << endl;

    cout << "sizeof(User): " << sizeof(Cor_User) << endl;

    cout << endl;
    cout << endl;
}
// *************************************************************************
