// *************************************************************************
//    TupleIterator.C
// *************************************************************************

#include "TupleIterator.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_TupleIterator::Cor_TupleIterator(Cor_Relation *rel, Cor_Tuple *tuple,
    Cor_Unify_Funct *unify, Cor_RMark *start, Cor_RMark *end)
    : arg_list(tuple->args())
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    // if (relation = rel)
    //   relation->scan_count++;
    relation = rel;

    arg_unify = unify;
    bindenv = NULL;

    bkt = NULL;
    start_mark = start;
    end_mark = end;
    indexnump = NULL;
    iter_type = Invalid_Iter;
    del_arglist = NULL;
    reset();
}

// *************************************************************************
Cor_TupleIterator::Cor_TupleIterator(Cor_Relation *rel, Cor_ArgList& args,
    Cor_BindEnv *env, Cor_Unify_Funct *unify,
    Cor_RMark *start, Cor_RMark *end, int *tryindexp)
    : arg_list(args)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    //if (relation = rel)
    //   relation->scan_count++;
    relation = rel;
    arg_unify = unify;

    bkt = NULL;
    bindenv = env;
    start_mark = start;
    end_mark = end;
    indexnump = tryindexp;
    iter_type = Invalid_Iter;
    del_arglist = NULL;
    reset();
}

// *************************************************************************
Cor_TupleIterator::~Cor_TupleIterator()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    // Should have already been released (release is not idempotent, darn it.)
    this->release();

    // if (tuple_env)         // Check if code is safe and reinsert it
    // delete tuple_env;

    switch (iter_type) {

    case Answer_Iter:
        delete answer_iterator;
        break;

    case Invalid_Iter:
    default:
        break; 
    }

    delete del_arglist;
}

// *************************************************************************
Cor_BindEnv  *Cor_TupleIterator::get_next()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif

    Cor_BindEnv *temp = relation->get_next(*this);
    while (_no_match && state) {
        _no_match = 0;
        (*state->solver)(state->md, state->magic, 0, this);
        temp = relation->get_next(*this);
    }
    return(temp);
}

// *************************************************************************
